<?php

/*
 This is the IMAP server config file. You need this if you set
 $default->user_change_server to false and $default->use_server_list
 The IMAPServer class contains the following variables:
 
 $name;
 $server;
 $port;
 $folders;
 $from_server;
 $preferred;
 
 name specifies the name to be displayed for the server in the
 select box, server is the hostname of the server. port is the imap port -
 by default 143. folders is the $folders variable to use; by default
 it's set to ''.
 
 preferred is only useful if you do want to use the same server.php3
 file for different machines: if the Hostname of the IMP Machine is
 identical to one of those in the preferred list, then the according
 option in the select box will include a SELECTED, ie. it is 
 selected per default. Otherwise the first entry in the list is 
 selected.
 
 The following is an example configuration:
 
 */

$IMAPServers = array();

$IMAPServers['osf'] = new IMAPServer('OSF (osfimap.isc.rit.edu)',
                    'osfimap.isc.rit.edu',
                    143,
                    'Mail/',
                       '');

$IMAPServers['vms'] = new IMAPServer('VMS (vmsimap.isc.rit.edu)',
                    'vmsimap.isc.rit.edu',
                    143,
                    '',
                    '');

$IMAPServers['csh'] = new IMAPServer('CSH (imap.csh.rit.edu)',
                    'imap.csh.rit.edu',
                    143,
                    'Mail/',
                    '');

?>
