<?php

/*
 
 File: folders.php3
 $Author: chuck $
 $Revision: 2.10.2.1 $
 $Date: 1999/08/07 21:11:36 $
 
 IMP: Copyright 1999 Charles J. Hagenbuch <chuck@horde.org>
 
 You should have received a copy of the GNU Public
 License along with this package; if not, write to the
 Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 Boston, MA 02111-1307, USA.
 
 */


$need_horde_db = 0;
$db_lib_loaded = 0;
require '../lib/horde.lib';
require './lib/imp.lib';           /* IMPlib is the IMP function library  */
require './config/defaults.php3';  /* Defaults configuration file */
require '../config/horde.php3';
/* Html styles configuration */
require './config/html.php3';

$language = select_lang();
require './locale/en/folders.lang';
if( $language != 'en' ) require "./locale/$language/folders.lang";
require './locale/local/folders.lang';
$help_file = 'folders.help';
require "./locale/defines/$help_file";

error_reporting($default->error_level);  /* set error level from imp.lib   */

caching_headers();

/* retrieve authentication information from session */
page_open(array('sess' => 'HordeSession'));
page_close();
if (!isset($imp) || !is_object($imp)) { header('Location: ' . $sess->url('login.php3?reason=logout')); exit; }
$imp->unpickle();
$imp->authenticate();

/* doctype */
require("$default->include_dir/doctype.inc");


$preamble = $imp->folders . $default->personal_folders;
$errormsg = '';
status('Folder management');

/* Run through the action handlers */

if (isset($actionID)) {
  switch($actionID) {
  case NO_ACTION:
    break;
    
  case DELETE_FOLDER:
    if ($dead_mailbox) {
      if ($default->use_imap_subscribe) { $boxes = mailbox_list(); }
      if (!(imap_deletemailbox($imp->stream, "{$imp->server:$imp->port}"."$dead_mailbox"))) {
	$errormsg = $lang->delete_folder_error;
      } else {
	if ($default->use_imap_subscribe) {
	  if (strstr($boxes, "\"$dead_mailbox\"")) {
	    if(!(imap_unsubscribe($imp->stream, "{$imp->server:$imp->port}$dead_mailbox"))) {
	      $errormsg = $lang->unsub_folder_error;
	    }
	  }
	}
      }
    }
    break;
    
  case CREATE_FOLDER:
    if ($new_mailbox) {
      if (!(imap_createmailbox($imp->stream, "{$imp->server:$imp->port}$preamble$new_mailbox"))) {
	$errormsg = $lang->create_folder_error;
      } else {
	if ($default->use_imap_subscribe) {
	  if(!(imap_subscribe($imp->stream,"{$imp->server:$imp->port}$preamble$new_mailbox"))) {
	    $errormsg = $lang->subscribe_folder_error;
	  }
	}
      }
    }
    break;
    
  case RENAME_FOLDER:
    if ($old_mailbox && $moved_mailbox) {
      if (!(imap_renamemailbox($imp->stream, "{$imp->server:$imp->port}$old_mailbox", "{$imp->server:$imp->port}$preamble" . "$moved_mailbox"))) {
	$errormsg = $lang->rename_folder_error;
      }
    }
    break;
    
  case SUBSCRIBE_FOLDER:
    if (isset($folderAdd)) {
      for ($i = 0; $i < count($folderAdd); $i++) {
	if (strspn($folderAdd[$i],'-') < 5) {
	  if (!(imap_subscribe($imp->stream,"{$imp->server:$imp->port}$folderAdd[$i]"))) {
	    $errormsg = $lang->subscribe_folder_error;
	  }
	}
      }
    }
    else {
      $errormsg = $lang->none_selected;
    }
    break;
    
  case UNSUBSCRIBE_FOLDER:
    if (isset($folderRemove)) {
      for ($i = 0; $i < count($folderRemove); $i++) {
	if (strspn($folderRemove[$i],'-') < 5) {
	  if (!(imap_unsubscribe($imp->stream, "{$imp->server:$imp->port}$folderRemove[$i]"))) {
	    $errormsg = $lang->unsub_folder_error;
	  }
	}
      }
    }
    else {
      $errormsg = $lang->none_selected;
    }
    break;
    
  }
}
if ($errormsg != '') { status($errormsg); }

$title = $lang->folders_title;
require("$default->include_dir/folders/header.inc");

$options = mailbox_list(false);
if ($default->use_imap_subscribe) {
  $newlist = full_mailbox_list(false);
  $unsublist = unsub_mailbox_list(false);
  include "$default->include_dir/folders/subscribe.inc";
}
else {
  $newlist = $options;
}
require "$default->include_dir/folders/create.inc";
require "$default->include_dir/folders/rename.inc";
require "$default->include_dir/folders/delete.inc";
require "$default->include_dir/generic-footer.inc";

?>
